<?
/*
  Virtual Freer
  http://freer.ir/virtual
  www.behbank.com
*/

/****************** behbank Class ******************/
class GateWay{

	private $apiUrl = 'http://behbank.com/ws';
	private $gatewayUrl = 'http://behbank.com/payment';

	public function paymentRequest($params){
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $this->apiUrl.'/payments/request.json');
		curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type' => 'application/json'));
		curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($params));
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		$response = json_decode(curl_exec($curl));
		curl_close($curl);
		if(isset($response->status) && $response->status == 1 ){
			return array(
				'status'    		=>  true,
				'paymentNumber'     =>  $response->paymentNumber,
			);
		}else{
			return array(
				'status'    =>  false,
				'message'   =>  $response->message,
			);
		}
	}

	public function paymentVerify($params){
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $this->apiUrl.'/payments/verify.json');
		curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type' => 'application/json'));
		curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode( $params ));
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		$response = json_decode(curl_exec($curl));
		curl_close($curl);
		if(isset($response->status) && $response->status == 1){
			return array(
				'status'    =>  true,
			);
		}else{
			return array(
				'status'    =>  false,
				'message'   =>  $response->message,
			);
		}
	}

	public function paymentGateway($paymentNumber){
		$paymentUrl = $this->gatewayUrl.'/'.$paymentNumber;
		if ( ! headers_sent() ) {
			header('Location: ' . $paymentUrl );
			die;
		}
		die('<script type="text/javascript">window.location="' .$paymentUrl. '";</script>');
	}

	public function getGatewayUrl(){
		return $this->gatewayUrl;
	}

}

//-- اطلاعات کلی پلاگین
$pluginData[gateway][type] = 'payment';
$pluginData[gateway][name] = 'بهبانک';
$pluginData[gateway][uniq] = 'gateway';
$pluginData[gateway][description] = 'مخصوص پرداخت با دروازه پرداخت <a href="http://behbank.com">بهبانک</a>';
$pluginData[gateway][author][name] = 'بهبانک';
$pluginData[gateway][author][url] = 'http://behbank.com';
$pluginData[gateway][author][email] = 'support@behbank.com';

//-- فیلدهای تنظیمات پلاگین
$pluginData[gateway][field][config][1][title] = 'مرچنت';
$pluginData[gateway][field][config][1][name] = 'merchant';
$pluginData[gateway][field][config][2][title] = 'عنوان خرید';
$pluginData[gateway][field][config][2][name] = 'title';

//-- تابع انتقال به دروازه پرداخت
function gateway__GateWay($data)
{
	global $config,$db,$smarty;
	$merchantID 	= trim($data['merchant']);
	$amount 		= round($data['amount']);
	$invoice_id		= $data['invoice_id'];
	$callBackUrl 	= $data['callback'];

	$sql 		= 'SELECT * FROM `payment` WHERE `payment_rand` = "'.$invoice_id.'" LIMIT 1;';
	$payment 	= $db->fetch($sql);

	$gateway = new GateWay();
	$params = array(
		'merchantCode' 	=> 	$merchantID,
		'amount' 		=> 	$amount,
		'callBackUrl' 	=> 	$callBackUrl,
		'invoiceNumber' => 	$invoice_id,
		'payerName'		=>	strlen($payment['payment_user']) ? $payment['payment_user'] : '',
		'payerEmail'	=>	$payment['payment_email'],
		'payerMobile'	=>	$payment['payment_mobile'],
	);
	$request = $gateway->paymentRequest($params);

	if ($request['status'])
	{
		$update['payment_rand']		= $request['paymentNumber'];
		$sql = $db->queryUpdate('payment', $update, 'WHERE `payment_rand` = "'.$invoice_id.'" LIMIT 1;');
		$db->execute($sql);
		$gateway->paymentGateway($request['paymentNumber']);
		exit;
	}
	else
	{
		$data['title'] = 'خطای سیستم';
		$data['message'] = '<div style="color:red;">در اتصال به درگاه پرداخت مشکلی به وجود آمد٬ لطفا از سایر درگاه ها استفاده نمایید.</div>'.$request['message'].'<br /><a href="index.php" class="button">بازگشت</a>';
		$query	= 'SELECT * FROM `config` WHERE `config_id` = "1" LIMIT 1';
		$conf	= $db->fetch($query);
		$smarty->assign('config', $conf);
		$smarty->assign('data', $data);
		$smarty->display('message.tpl');
	}
}

//-- تابع بررسی وضعیت پرداخت
function callback__GateWay($data)
{
	global $db;

	$invoiceNumber = isset($_POST['invoiceNumber']) ? $_POST['invoiceNumber'] : '';
	$paymentNumber = isset($_POST['paymentNumber']) ? $_POST['paymentNumber'] : '';

	if (isset($_POST['status']) && $_POST['status'] == 1)
	{
		include_once('gateway.php');
		$merchantID = $data['merchant'];
		$sql 		= 'SELECT * FROM `payment` WHERE `payment_rand` = "'.$paymentNumber.'" LIMIT 1;';
		$payment 	= $db->fetch($sql);

		$mg = new GateWay();
		$params = array(
			'merchantCode' => $merchantID,
			'paymentNumber' => $paymentNumber,
		);
		$request = $mg->paymentVerify($params);

		if ($payment['payment_status'] == 1)
		{
			if ($request['status'])//-- موفقیت آمیز
			{
				//-- آماده کردن خروجی
				$output['status']		= 1;
				$output['res_num']	= $invoiceNumber;
				$output['ref_num']	= $paymentNumber;
				$output['payment_id']	= $payment['payment_id'];
			}
			else
			{
				//-- در تایید پرداخت مشکلی به‌وجود آمده است‌
				$output['status']	= 0;
				$output['message']= 'پرداخت توسط درگاه پرداخت تایید نشد‌.'.$request['message'];
			}
		}
		else
		{
			//-- قبلا پرداخت شده است‌
			$output['status']	= 0;
			$output['message']= 'سفارش قبلا پرداخت شده است.';
		}
	}
	else
	{
			//-- شماره یکتا اشتباه است
			$output['status']	= 0;
			$output['message']= 'شماره یکتا اشتباه است.';
	}
	return $output;
}
